<?php
namespace Avaliacao\Repositories;

class Participaval extends \Doctrine\ORM\EntityRepository 
{
    public static function retornaAvaliadorEAvaliadoLiderLiderado($params2){
        
      $sql = "SELECT PARTICIPAVAL.NRPARCAVALIADO, PARTICIPAVAL.NRPARCEXECAVAL 
               FROM PARTICIPAVAL, AVALIACAOGERAL, COMBQUESTAVAL
                WHERE AVALIACAOGERAL.NRAVALIACAO = PARTICIPAVAL.NRAVALIACAO
                AND AVALIACAOGERAL.NRAVALIACAO = COMBQUESTAVAL.NRAVALIACAO
                AND COMBQUESTAVAL.NRCOMBQUESTAVAL = PARTICIPAVAL.NRCOMBQUESTAVAL
                AND PARTICIPAVAL.NRPARCEXECAVAL = :P_NRPARCEXECAVAL
                AND PARTICIPAVAL.NRPARCAVALIADO = :P_NRPARCAVALIADO
                AND AVALIACAOGERAL.NRAVALIACAO = :P_NRAVALIACAO";
        try {
            $retorno = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params2);
            return $retorno;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    
    public static function retornaAvaliadorEAvaliadoLideradoLider($params2){
        
      $sql = "SELECT PARTICIPAVAL.NRPARCAVALIADO, PARTICIPAVAL.NRPARCEXECAVAL 
                FROM PARTICIPAVAL, AVALIACAOGERAL, COMBQUESTAVAL
                WHERE AVALIACAOGERAL.NRAVALIACAO = PARTICIPAVAL.NRAVALIACAO
                AND AVALIACAOGERAL.NRAVALIACAO = COMBQUESTAVAL.NRAVALIACAO
                AND COMBQUESTAVAL.NRCOMBQUESTAVAL = PARTICIPAVAL.NRCOMBQUESTAVAL
                AND PARTICIPAVAL.NRPARCEXECAVAL = :P_NRPARCEXECAVAL
                AND PARTICIPAVAL.NRPARCAVALIADO = :P_NRPARCAVALIADO
                AND AVALIACAOGERAL.NRAVALIACAO = :P_NRAVALIACAO";
        try {
            $retorno = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params2);
            return $retorno;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    
    public static function retornaListaParticipantes($params){
        
      $sql = "SELECT PARTICIPAVAL.NRPARCAVALIADO, PARTICIPAVAL.NRPARCEXECAVAL 
                FROM PARTICIPAVAL, AVALIACAOGERAL, COMBQUESTAVAL
               WHERE AVALIACAOGERAL.NRAVALIACAO = PARTICIPAVAL.NRAVALIACAO
                 AND AVALIACAOGERAL.NRAVALIACAO = COMBQUESTAVAL.NRAVALIACAO
                 AND COMBQUESTAVAL.NRCOMBQUESTAVAL = PARTICIPAVAL.NRCOMBQUESTAVAL
                 AND PARTICIPAVAL.NRPARCEXECAVAL = :P_NRPARCEXECAVAL
                 AND PARTICIPAVAL.NRPARCAVALIADO = :P_NRPARCAVALIADO
                 AND AVALIACAOGERAL.NRAVALIACAO  = :P_NRAVALIACAO";
        try {
            $retorno = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
            return $retorno;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    
    public static function lista_participante_combquest($params){
      $sql = "SELECT * 
                FROM PARTICIPAVAL 
               WHERE NRAVALIACAO = :P_NRAVAL";
        try {
            $retorno = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
            return $retorno;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public static function update_participavalCombinacaoPadrao($params){
            $sql = "UPDATE PARTICIPAVAL
                       SET NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
                     WHERE NRAVALIACAO = :P_NRAVALIACAO";
        try {
            \Setforms2\Shared\Registry::getEntityManagerConnection()->executeQuery($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public static function retornaColaboradoresAvaliacaoConcluidaRepository($arrayNravaliacao){
    //Retorna o nr da combinacao e o nr dos parceiros que foram avaliados (concluidas), de acordo com a avaliacao informada
        $sqlParticipOk = "SELECT DISTINCT PARTICIPAVAL.NRCOMBQUESTAVAL, PARTICIPAVAL.NRPARCAVALIADO, PARTICIPAVAL.NRPARCEXECAVAL, PARTICIPAVAL.NRPARTICIPAVAL
                            FROM PARTICIPAVAL, TIPORELACIONA, EXECAVALIACAO, TIPORELACAVAL
                           WHERE PARTICIPAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                          AND PARTICIPAVAL.NRAVALIACAO = EXECAVALIACAO.NRAVALIACAO
                          AND PARTICIPAVAL.NRCOMBQUESTAVAL = EXECAVALIACAO.NRCOMBQUESTAVAL
                          AND PARTICIPAVAL.NRPARCAVALIADO = EXECAVALIACAO.NRPARCAVALIADO
                          AND PARTICIPAVAL.NRPARCEXECAVAL = EXECAVALIACAO.NRPARCEXECAVAL
                          AND TIPORELACIONA.NRTIPORELACIONA = TIPORELACAVAL.NRTIPORELACIONA
                          AND PARTICIPAVAL.NRAVALIACAO = :P_NRAVALIACAO
                          AND PARTICIPAVAL.VRRESULTAVALIA IS NULL
                          AND IDSITUACAOAVAL = 'CONCLUIDA'
                          AND PARTICIPAVAL.NRCOMBQUESTAVAL || PARTICIPAVAL.NRPARCAVALIADO NOT IN (SELECT DISTINCT PARTICIPAVAL.NRCOMBQUESTAVAL || APLIC.NRPARCNEGOCIO NRAVALIADO
                          FROM  EXECAVALIACAO, AVALIACAOGERAL, TIPOAVALIACAO, TIPORELACIONA, PARTICIPAVAL, PARCNEGOCIO EXEC, PARCNEGOCIO APLIC
                          WHERE AVALIACAOGERAL.NRTIPOAVALIACAO = TIPOAVALIACAO.NRTIPOAVALIACAO
                          AND PARTICIPAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                          AND PARTICIPAVAL.nrparcavaliado = EXECAVALIACAO.nrparcavaliado
                          AND PARTICIPAVAL.nrparcexecaval = EXECAVALIACAO.nrparcexecaval
                          AND PARTICIPAVAL.nravaliacao = EXECAVALIACAO.nravaliacao
                          AND PARTICIPAVAL.nrcombquestaval = EXECAVALIACAO.nrcombquestaval
                          AND EXEC.NRPARCNEGOCIO = EXECAVALIACAO.NRPARCEXECAVAL
                          AND APLIC.NRPARCNEGOCIO = EXECAVALIACAO.NRPARCAVALIADO
                          AND EXECAVALIACAO.NRORG = AVALIACAOGERAL.NRORG
                          AND EXECAVALIACAO.NRAVALIACAO = AVALIACAOGERAL.NRAVALIACAO
                          AND PARTICIPAVAL.NRAVALIACAO = :P_NRAVALIACAO
                          AND PARTICIPAVAL.IDSITUACAOAVAL <> 'CONCLUIDA')
                          ORDER BY PARTICIPAVAL.NRPARCAVALIADO";
        $resultParticipOk = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sqlParticipOk, $arrayNravaliacao);
        return $resultParticipOk;
    }
    
    public function updateResultadoApurado($params){
        $sqlparams = "UPDATE PARTICIPAVAL 
                         SET VRRESULTAVALIA  = :P_VRRESULTAVALIA, 
                             CDTIPORESU      = :P_CDTIPORESU
                       WHERE NRAVALIACAO     = :P_NRAVALIACAO
                         AND NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
                         AND NRPARCAVALIADO  = :P_NRPARCAVALIADO
                         AND NRPARCEXECAVAL  = :P_NRPARCEXECAVAL
                         AND IDSITUACAOAVAL  = :P_IDSITUACAOAVAL";
        \Setforms2\Shared\Registry::getEntityManagerConnection()->executeQuery($sqlparams, $params);
    }
    
    
    public function updateDesfazApuracao($params){
        $sqlparams = "UPDATE PARTICIPAVAL 
                         SET VRRESULTAVALIA  = :P_VRRESULTAVALIA, 
                             CDTIPORESU      = :P_CDTIPORESU
                       WHERE NRPARCAVALIADO  = :P_NRPARCAVALIADO
                         AND NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
                         AND NRAVALIACAO     = :P_NRAVALIACAO
                         AND NRORG           = :P_NRORG";
        \Setforms2\Shared\Registry::getEntityManagerConnection()->executeQuery($sqlparams, $params);
    }
    
//    public function retornaResultadoColaboradorRepository($params){
//        $sqlResult = "SELECT ROUND((SUM(SUM(MEDIA_RELAC) / SUM(PESORELAC)) / COUNT(NRQUESTAO)), 2) RESULTADO
//                        FROM
//                          (SELECT QUESTAVALIACAO.NRQUESTAO,
//                            QUESTAO.TXQUESTAO,
//                            TIPORELACIONA.NMTIPORELACIONA,
//                            TIPORELACAVAL.VRPESORELACAVAL                                    AS PESORELAC,
//                            ( AVG(RESPOSTA.VRPESORESPOSTA) * TIPORELACAVAL.VRPESORELACAVAL ) AS MEDIA_RELAC
//                          FROM PARCNEGOCIO EXEC,
//                            PARCNEGOCIO APLIC,
//                            TIPORELACIONA,
//                            QUESTAO,
//                            RESPOSTA,
//                            EXECAVALIACAO,
//                            RESPAVALIACAO,
//                            AVALIACAOGERAL,
//                            PARTICIPAVAL,
//                            COMBQUESTAVAL,
//                            QUESTAVALIACAO,
//                            TIPORELACAVAL
//                          WHERE QUESTAO.NRQUESTAO           = RESPOSTA.NRQUESTAO
//                          AND QUESTAO.NRQUESTAO             = EXECAVALIACAO.NRQUESTAO
//                          AND RESPOSTA.NRRESPOSTA           = RESPAVALIACAO.NRRESPOSTA
//                          AND EXECAVALIACAO.NREXECAVALIACAO = RESPAVALIACAO.NREXECAVALIACAO
//                          AND EXEC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCEXECAVAL
//                          AND APLIC.NRPARCNEGOCIO           = EXECAVALIACAO.NRPARCAVALIADO
//                          AND EXECAVALIACAO.NRAVALIACAO     = AVALIACAOGERAL.NRAVALIACAO
//                          AND AVALIACAOGERAL.NRAVALIACAO    = PARTICIPAVAL.NRAVALIACAO
//                          AND TIPORELACIONA.NRTIPORELACIONA = PARTICIPAVAL.NRTIPORELACIONA
//                          AND (AVALIACAOGERAL.NRAVALIACAO   = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
//                          AND COMBQUESTAVAL.NRCOMBQUESTAVAL = QUESTAVALIACAO.NRCOMBQUESTAVAL
//                          AND QUESTAVALIACAO.NRQUESTAO      = QUESTAO.NRQUESTAO
//                          AND COMBQUESTAVAL.NRCOMBQUESTAVAL = PARTICIPAVAL.NRCOMBQUESTAVAL
//                          AND EXEC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCEXECAVAL
//                          AND APLIC.NRPARCNEGOCIO           = PARTICIPAVAL.NRPARCAVALIADO
//                          AND AVALIACAOGERAL.NRAVALIACAO    = TIPORELACAVAL.NRAVALIACAO
//                          AND TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
//                          AND AVALIACAOGERAL.NRORG          = QUESTAO.NRORG
//                          AND AVALIACAOGERAL.NRORG          = EXEC.NRORG
//                          AND AVALIACAOGERAL.NRORG          = APLIC.NRORG
//                          AND AVALIACAOGERAL.NRORG          = RESPOSTA.NRORG
//                          AND AVALIACAOGERAL.NRORG          = EXECAVALIACAO.NRORG
//                          AND AVALIACAOGERAL.NRORG          = RESPAVALIACAO.NRORG
//                          AND AVALIACAOGERAL.NRORG          = PARTICIPAVAL.NRORG
//                          AND AVALIACAOGERAL.NRORG          = QUESTAVALIACAO.NRORG
//                            /* IGNORA questoes que receberam resposta como NAO SE APLICA */
//                          AND RESPOSTA.VRPESORESPOSTA > -1
//                          AND QUESTAO.NRQUESTAO NOT    IN
//                            (SELECT QUESTAO.NRQUESTAO
//                            FROM PARCNEGOCIO EXEC,
//                              PARCNEGOCIO APLIC,
//                              TIPORELACIONA,
//                              QUESTAO,
//                              RESPOSTA,
//                              EXECAVALIACAO,
//                              RESPAVALIACAO,
//                              PARTICIPAVAL,
//                              COMBQUESTAVAL,
//                              QUESTAVALIACAO,
//                              TIPORELACAVAL
//                            WHERE QUESTAO.NRQUESTAO           = RESPOSTA.NRQUESTAO
//                            AND QUESTAO.NRQUESTAO             = EXECAVALIACAO.NRQUESTAO
//                            AND RESPOSTA.NRRESPOSTA           = RESPAVALIACAO.NRRESPOSTA
//                            AND EXECAVALIACAO.NREXECAVALIACAO = RESPAVALIACAO.NREXECAVALIACAO
//                            AND EXEC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCEXECAVAL
//                            AND APLIC.NRPARCNEGOCIO           = EXECAVALIACAO.NRPARCAVALIADO
//                            AND EXECAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
//                            AND PARTICIPAVAL.NRAVALIACAO      = :P_NRAVALIACAO
//                            AND TIPORELACIONA.NRTIPORELACIONA = PARTICIPAVAL.NRTIPORELACIONA
//                            AND :P_NRAVALIACAO                = COMBQUESTAVAL.NRAVALIACAO
//                            AND COMBQUESTAVAL.NRCOMBQUESTAVAL = QUESTAVALIACAO.NRCOMBQUESTAVAL
//                            AND QUESTAVALIACAO.NRQUESTAO      = QUESTAO.NRQUESTAO
//                            AND COMBQUESTAVAL.NRCOMBQUESTAVAL = PARTICIPAVAL.NRCOMBQUESTAVAL
//                            AND EXEC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCEXECAVAL
//                            AND APLIC.NRPARCNEGOCIO           = PARTICIPAVAL.NRPARCAVALIADO
//                            AND :P_NRAVALIACAO                = TIPORELACAVAL.NRAVALIACAO
//                            AND TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
//                              /* filtra questoes que receberam resposta como NAO SE APLICA */
//                            AND RESPOSTA.VRPESORESPOSTA = -1
//                              /* filtra com o maior peso existente para a avaliacao*/
//                            AND TIPORELACIONA.NRTIPORELACIONA IN
//                              (SELECT TIPORELACIONA.NRTIPORELACIONA
//                              FROM TIPORELACAVAL,
//                                TIPORELACIONA
//                              WHERE TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
//                              AND TIPORELACAVAL.VRPESORELACAVAL   =
//                                (SELECT MAX(TIPORELACAVAL.VRPESORELACAVAL)
//                                FROM TIPORELACAVAL
//                                WHERE TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
//                                )
//                              AND TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
//                              )
//                            AND EXECAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
//                            AND EXECAVALIACAO.NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
//                            AND EXECAVALIACAO.NRPARCAVALIADO  = :P_NRPARCAVALIADO
//                            AND PARTICIPAVAL.IDSITUACAOAVAL   = 'CONCLUIDA'
//                            )
//                          AND EXECAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
//                          AND EXECAVALIACAO.NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
//                          AND EXECAVALIACAO.NRPARCAVALIADO  = :P_NRPARCAVALIADO
//                          AND PARTICIPAVAL.IDSITUACAOAVAL   = 'CONCLUIDA'
//                          AND AVALIACAOGERAL.NRORG          = :P_NRORG
//                          GROUP BY QUESTAVALIACAO.NRQUESTAO,
//                            QUESTAO.TXQUESTAO,
//                            TIPORELACIONA.NMTIPORELACIONA,
//                            TIPORELACAVAL.VRPESORELACAVAL
//                          ORDER BY QUESTAVALIACAO.NRQUESTAO
//                          )
//                        GROUP BY NRQUESTAO
//                        ORDER BY NRQUESTAO";
//        $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sqlResult, $params);
//        return $result;
//    }
    
    public function retornaResultadoColaboradorRepository($params){
        $sql = "SELECT ROUND(AVG(MEDIA_RELAC), 2) AS RESULTADO
                FROM
                  (SELECT QUESTAVALIACAO.NRQUESTAO,
                    QUESTAO.TXQUESTAO,
                    TIPORELACIONA.NMTIPORELACIONA,
                    TIPORELACAVAL.VRPESORELACAVAL  AS PESORELAC,
                    (AVG(RESPOSTA.VRPESORESPOSTA)) AS MEDIA_RELAC
                  FROM PARCNEGOCIO EXEC,
                    PARCNEGOCIO APLIC,
                    TIPORELACIONA,
                    QUESTAO,
                    RESPOSTA,
                    EXECAVALIACAO,
                    RESPAVALIACAO,
                    AVALIACAOGERAL,
                    PARTICIPAVAL,
                    COMBQUESTAVAL,
                    QUESTAVALIACAO,
                    TIPORELACAVAL
                  WHERE QUESTAO.NRQUESTAO           = RESPOSTA.NRQUESTAO
                  AND QUESTAO.NRQUESTAO             = EXECAVALIACAO.NRQUESTAO
                  AND RESPOSTA.NRRESPOSTA           = RESPAVALIACAO.NRRESPOSTA
                  AND EXECAVALIACAO.NREXECAVALIACAO = RESPAVALIACAO.NREXECAVALIACAO
                  AND EXECAVALIACAO.NRAVALIACAO     = AVALIACAOGERAL.NRAVALIACAO
                  AND EXEC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCEXECAVAL
                  AND EXEC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCEXECAVAL
                  AND APLIC.NRPARCNEGOCIO           = EXECAVALIACAO.NRPARCAVALIADO
                  AND APLIC.NRPARCNEGOCIO           = PARTICIPAVAL.NRPARCAVALIADO
                  AND AVALIACAOGERAL.NRAVALIACAO    = PARTICIPAVAL.NRAVALIACAO
                  AND (AVALIACAOGERAL.NRAVALIACAO   = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
                  AND COMBQUESTAVAL.NRCOMBQUESTAVAL = QUESTAVALIACAO.NRCOMBQUESTAVAL
                  AND COMBQUESTAVAL.NRCOMBQUESTAVAL = PARTICIPAVAL.NRCOMBQUESTAVAL
                  AND TIPORELACIONA.NRTIPORELACIONA = PARTICIPAVAL.NRTIPORELACIONA
                  AND QUESTAVALIACAO.NRQUESTAO      = QUESTAO.NRQUESTAO
                  AND AVALIACAOGERAL.NRAVALIACAO    = TIPORELACAVAL.NRAVALIACAO
                  AND TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                  AND AVALIACAOGERAL.NRORG          = QUESTAO.NRORG
                  AND AVALIACAOGERAL.NRORG          = EXEC.NRORG
                  AND AVALIACAOGERAL.NRORG          = APLIC.NRORG
                  AND AVALIACAOGERAL.NRORG          = RESPOSTA.NRORG
                  AND AVALIACAOGERAL.NRORG          = EXECAVALIACAO.NRORG
                  AND AVALIACAOGERAL.NRORG          = RESPAVALIACAO.NRORG
                  AND AVALIACAOGERAL.NRORG          = PARTICIPAVAL.NRORG
                  AND AVALIACAOGERAL.NRORG          = QUESTAVALIACAO.NRORG
                    /* IGNORA questoes que receberam resposta como NAO SE APLICA */
                  AND RESPOSTA.VRPESORESPOSTA > -1
                  AND QUESTAO.NRQUESTAO NOT    IN
                    (SELECT QUESTAO.NRQUESTAO
                    FROM PARCNEGOCIO EXEC,
                      PARCNEGOCIO APLIC,
                      TIPORELACIONA,
                      QUESTAO,
                      RESPOSTA,
                      EXECAVALIACAO,
                      RESPAVALIACAO,
                      PARTICIPAVAL,
                      COMBQUESTAVAL,
                      QUESTAVALIACAO,
                      TIPORELACAVAL
                    WHERE QUESTAO.NRQUESTAO           = RESPOSTA.NRQUESTAO
                    AND QUESTAO.NRQUESTAO             = EXECAVALIACAO.NRQUESTAO
                    AND RESPOSTA.NRRESPOSTA           = RESPAVALIACAO.NRRESPOSTA
                    AND EXECAVALIACAO.NREXECAVALIACAO = RESPAVALIACAO.NREXECAVALIACAO
                    AND EXEC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCEXECAVAL
                    AND APLIC.NRPARCNEGOCIO           = EXECAVALIACAO.NRPARCAVALIADO
                    AND EXECAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
                    AND PARTICIPAVAL.NRAVALIACAO      = :P_NRAVALIACAO
                    AND TIPORELACIONA.NRTIPORELACIONA = PARTICIPAVAL.NRTIPORELACIONA
                    AND :P_NRAVALIACAO                = COMBQUESTAVAL.NRAVALIACAO
                    AND COMBQUESTAVAL.NRCOMBQUESTAVAL = QUESTAVALIACAO.NRCOMBQUESTAVAL
                    AND QUESTAVALIACAO.NRQUESTAO      = QUESTAO.NRQUESTAO
                    AND COMBQUESTAVAL.NRCOMBQUESTAVAL = PARTICIPAVAL.NRCOMBQUESTAVAL
                    AND EXEC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCEXECAVAL
                    AND APLIC.NRPARCNEGOCIO           = PARTICIPAVAL.NRPARCAVALIADO
                    AND :P_NRAVALIACAO                = TIPORELACAVAL.NRAVALIACAO
                    AND TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                      /* filtra questoes que receberam resposta como NAO SE APLICA */
                    AND RESPOSTA.VRPESORESPOSTA       = -1
                    AND EXECAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
                    AND EXECAVALIACAO.NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
                    AND EXECAVALIACAO.NRPARCAVALIADO  = :P_NRPARCAVALIADO
                    AND EXECAVALIACAO.NRPARCEXECAVAL  = :P_NRPARCEXECAVAL
                    AND PARTICIPAVAL.IDSITUACAOAVAL   = 'CONCLUIDA'
                    )
                  AND EXECAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
                  AND EXECAVALIACAO.NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
                  AND EXECAVALIACAO.NRPARCAVALIADO  = :P_NRPARCAVALIADO
                  AND EXECAVALIACAO.NRPARCEXECAVAL  = :P_NRPARCEXECAVAL
                  AND AVALIACAOGERAL.NRORG          = :P_NRORG
                  AND PARTICIPAVAL.IDSITUACAOAVAL   = 'CONCLUIDA'
                  GROUP BY QUESTAVALIACAO.NRQUESTAO,
                    QUESTAO.TXQUESTAO,
                    TIPORELACIONA.NMTIPORELACIONA,
                    TIPORELACAVAL.VRPESORELACAVAL
                  ORDER BY QUESTAVALIACAO.NRQUESTAO
                  )";
        $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
        return $result;
    }
    
    
    public function retornaColaboradoresApuradosRepository($params){
        //retorna todos os parceiros apurados
        $sqlAvaliados = "SELECT DISTINCT PARTICIPAVAL.NRPARCAVALIADO,
                              COMBQUESTAVAL.NRCOMBQUESTAVAL,
                              COMBQUESTAVAL.NMCOMBQUESTAVAL,
                              APLIC.NMPRINCIPALPARC AVALIADO,
                              PARTICIPAVAL.VRRESULTAVALIA,
                              TIPORESU.NMTIPORESU
                            FROM AVALIACAOGERAL,
                              TIPOAVALIACAO,
                              TIPORELACIONA,
                              PARTICIPAVAL,
                              PARCNEGOCIO EXEC,
                              PARCNEGOCIO APLIC,
                              TIPORESU,
                              COMBQUESTAVAL
                            WHERE AVALIACAOGERAL.NRTIPOAVALIACAO = TIPOAVALIACAO.NRTIPOAVALIACAO
                            AND PARTICIPAVAL.NRTIPORELACIONA     = TIPORELACIONA.NRTIPORELACIONA
                            AND EXEC.NRPARCNEGOCIO               = PARTICIPAVAL.NRPARCEXECAVAL
                            AND APLIC.NRPARCNEGOCIO              = PARTICIPAVAL.NRPARCAVALIADO
                            AND PARTICIPAVAL.NRAVALIACAO         = AVALIACAOGERAL.NRAVALIACAO
                            AND (AVALIACAOGERAL.NRAVALIACAO      = COMBQUESTAVAL.NRAVALIACAO
                            OR COMBQUESTAVAL.NRAVALIACAO        IS NULL)
                            AND PARTICIPAVAL.CDTIPORESU          = TIPORESU.CDTIPORESU(+)
                            AND PARTICIPAVAL.NRAVALIACAO         = :P_NRAVALIACAO
                            AND PARTICIPAVAL.NRORG               = :P_NRORG
                            AND PARTICIPAVAL.IDSITUACAOAVAL      = 'CONCLUIDA'
                            AND PARTICIPAVAL.VRRESULTAVALIA     IS NOT NULL";
        $conn = \Setforms2\Shared\Registry::getEntityManagerConnection();
        $colaboradoresApurados = $conn->fetchAll($sqlAvaliados, $params);
        return $colaboradoresApurados;
    }
    
    /*
     * retorna o numero da participaval filtrando pelo maior peso
     */
    public function retornaNrparticipavalMaiorRelacionamento($params){
        $sql = "SELECT PARTICIPAVAL.NRPARTICIPAVAL
                  FROM PARTICIPAVAL
                 WHERE NRPARCAVALIADO = :P_NRPARCAVALIADO
                   AND NRAVALIACAO = :P_NRAVALIACAO
                   and nrtiporelaciona = (select tiporelaciona.nrtiporelaciona
                  from tiporelacaval, tiporelaciona
                 where tiporelacaval.nrtiporelaciona = tiporelaciona.nrtiporelaciona
                   and tiporelacaval.vrpesorelacaval = (select max(tiporelacaval.vrpesorelacaval)
                                                          from tiporelacaval
                                                         where tiporelacaval.nravaliacao = :P_NRAVALIACAO)
                                                           and tiporelacaval.nravaliacao = :P_NRAVALIACAO)";
        $conn = \Setforms2\Shared\Registry::getEntityManagerConnection();
        $nrparticipavalMaiorRelacionamento = $conn->fetchAll($sql, $params);
        return $nrparticipavalMaiorRelacionamento;
    }

    /*
     * retorna todas participaval do avaliado
     */
    public function retornaNrparticipavalRelacionamentos($params){
        $sql = "SELECT PARTICIPAVAL.NRPARTICIPAVAL
                  FROM PARTICIPAVAL
                 WHERE NRPARCAVALIADO = :P_NRPARCAVALIADO
                   AND NRPARCEXECAVAL = :P_NRPARCEXECAVAL
                   AND NRAVALIACAO = :P_NRAVALIACAO
                   AND NRORG       = :P_NRORG
                   AND IDSITUACAOAVAL = 'CONCLUIDA'";

        $conn = \Setforms2\Shared\Registry::getEntityManagerConnection();
        $nrparticipavalMaiorRelacionamento = $conn->fetchAll($sql, $params);
        return $nrparticipavalMaiorRelacionamento;
    }

    public function resultadoPonderadoAvaliacaoRepository($params){
           $sqlResult = "SELECT ROUND((SUM(SUM(MEDIA_RELAC) / SUM(PESORELAC)) / COUNT(NRQUESTAO)), 2) RESULTADO
                        FROM
                          (SELECT QUESTAVALIACAO.NRQUESTAO,
                            QUESTAO.TXQUESTAO,
                            TIPORELACIONA.NMTIPORELACIONA,
                            TIPORELACAVAL.VRPESORELACAVAL                                    AS PESORELAC,
                            ( AVG(RESPOSTA.VRPESORESPOSTA) * TIPORELACAVAL.VRPESORELACAVAL ) AS MEDIA_RELAC
                          FROM PARCNEGOCIO EXEC,
                            PARCNEGOCIO APLIC,
                            TIPORELACIONA,
                            QUESTAO,
                            RESPOSTA,
                            EXECAVALIACAO,
                            RESPAVALIACAO,
                            AVALIACAOGERAL,
                            PARTICIPAVAL,
                            COMBQUESTAVAL,
                            QUESTAVALIACAO,
                            TIPORELACAVAL
                          WHERE QUESTAO.NRQUESTAO           = RESPOSTA.NRQUESTAO
                          AND QUESTAO.NRQUESTAO             = EXECAVALIACAO.NRQUESTAO
                          AND RESPOSTA.NRRESPOSTA           = RESPAVALIACAO.NRRESPOSTA
                          AND EXECAVALIACAO.NREXECAVALIACAO = RESPAVALIACAO.NREXECAVALIACAO
                          AND EXEC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCEXECAVAL
                          AND APLIC.NRPARCNEGOCIO           = EXECAVALIACAO.NRPARCAVALIADO
                          AND EXECAVALIACAO.NRAVALIACAO     = AVALIACAOGERAL.NRAVALIACAO
                          AND AVALIACAOGERAL.NRAVALIACAO    = PARTICIPAVAL.NRAVALIACAO
                          AND TIPORELACIONA.NRTIPORELACIONA = PARTICIPAVAL.NRTIPORELACIONA
                          AND (AVALIACAOGERAL.NRAVALIACAO   = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
                          AND COMBQUESTAVAL.NRCOMBQUESTAVAL = QUESTAVALIACAO.NRCOMBQUESTAVAL
                          AND QUESTAVALIACAO.NRQUESTAO      = QUESTAO.NRQUESTAO
                          AND COMBQUESTAVAL.NRCOMBQUESTAVAL = PARTICIPAVAL.NRCOMBQUESTAVAL
                          AND EXEC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCEXECAVAL
                          AND APLIC.NRPARCNEGOCIO           = PARTICIPAVAL.NRPARCAVALIADO
                          AND AVALIACAOGERAL.NRAVALIACAO    = TIPORELACAVAL.NRAVALIACAO
                          AND TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                          AND AVALIACAOGERAL.NRORG          = QUESTAO.NRORG
                          AND AVALIACAOGERAL.NRORG          = EXEC.NRORG
                          AND AVALIACAOGERAL.NRORG          = APLIC.NRORG
                          AND AVALIACAOGERAL.NRORG          = RESPOSTA.NRORG
                          AND AVALIACAOGERAL.NRORG          = EXECAVALIACAO.NRORG
                          AND AVALIACAOGERAL.NRORG          = RESPAVALIACAO.NRORG
                          AND AVALIACAOGERAL.NRORG          = PARTICIPAVAL.NRORG
                          AND AVALIACAOGERAL.NRORG          = QUESTAVALIACAO.NRORG
                            /* IGNORA questoes que receberam resposta como NAO SE APLICA */
                          AND RESPOSTA.VRPESORESPOSTA > -1
                          AND QUESTAO.NRQUESTAO NOT    IN
                            (SELECT QUESTAO.NRQUESTAO
                            FROM PARCNEGOCIO EXEC,
                              PARCNEGOCIO APLIC,
                              TIPORELACIONA,
                              QUESTAO,
                              RESPOSTA,
                              EXECAVALIACAO,
                              RESPAVALIACAO,
                              PARTICIPAVAL,
                              COMBQUESTAVAL,
                              QUESTAVALIACAO,
                              TIPORELACAVAL
                            WHERE QUESTAO.NRQUESTAO           = RESPOSTA.NRQUESTAO
                            AND QUESTAO.NRQUESTAO             = EXECAVALIACAO.NRQUESTAO
                            AND RESPOSTA.NRRESPOSTA           = RESPAVALIACAO.NRRESPOSTA
                            AND EXECAVALIACAO.NREXECAVALIACAO = RESPAVALIACAO.NREXECAVALIACAO
                            AND EXEC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCEXECAVAL
                            AND APLIC.NRPARCNEGOCIO           = EXECAVALIACAO.NRPARCAVALIADO
                            AND EXECAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
                            AND PARTICIPAVAL.NRAVALIACAO      = :P_NRAVALIACAO
                            AND TIPORELACIONA.NRTIPORELACIONA = PARTICIPAVAL.NRTIPORELACIONA
                            AND :P_NRAVALIACAO                = COMBQUESTAVAL.NRAVALIACAO
                            AND COMBQUESTAVAL.NRCOMBQUESTAVAL = QUESTAVALIACAO.NRCOMBQUESTAVAL
                            AND QUESTAVALIACAO.NRQUESTAO      = QUESTAO.NRQUESTAO
                            AND COMBQUESTAVAL.NRCOMBQUESTAVAL = PARTICIPAVAL.NRCOMBQUESTAVAL
                            AND EXEC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCEXECAVAL
                            AND APLIC.NRPARCNEGOCIO           = PARTICIPAVAL.NRPARCAVALIADO
                            AND :P_NRAVALIACAO                = TIPORELACAVAL.NRAVALIACAO
                            AND TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                              /* filtra questoes que receberam resposta como NAO SE APLICA */
                            AND RESPOSTA.VRPESORESPOSTA = -1
                              /* filtra com o maior peso existente para a avaliacao*/
                            AND TIPORELACIONA.NRTIPORELACIONA IN
                              (SELECT TIPORELACIONA.NRTIPORELACIONA
                              FROM TIPORELACAVAL,
                                TIPORELACIONA
                              WHERE TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                              AND TIPORELACAVAL.VRPESORELACAVAL   =
                                (SELECT MAX(TIPORELACAVAL.VRPESORELACAVAL)
                                FROM TIPORELACAVAL
                                WHERE TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
                                )
                              AND TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
                              )
                            AND EXECAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
                            AND EXECAVALIACAO.NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
                            AND EXECAVALIACAO.NRPARCAVALIADO  = :P_NRPARCAVALIADO
                            AND PARTICIPAVAL.IDSITUACAOAVAL   = 'CONCLUIDA'
                            )
                          AND EXECAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
                          AND EXECAVALIACAO.NRCOMBQUESTAVAL = :P_NRCOMBQUESTAVAL
                          AND EXECAVALIACAO.NRPARCAVALIADO  = :P_NRPARCAVALIADO
                          AND PARTICIPAVAL.IDSITUACAOAVAL   = 'CONCLUIDA'
                          AND AVALIACAOGERAL.NRORG          = :P_NRORG
                          GROUP BY QUESTAVALIACAO.NRQUESTAO,
                            QUESTAO.TXQUESTAO,
                            TIPORELACIONA.NMTIPORELACIONA,
                            TIPORELACAVAL.VRPESORELACAVAL
                          ORDER BY QUESTAVALIACAO.NRQUESTAO
                          )
                        GROUP BY NRQUESTAO
                        ORDER BY NRQUESTAO";
        $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sqlResult, $params);
        return $result;
    }
    
    public function retornaNrtiporelacionaParcexecaval($params){
        $sql = "SELECT DISTINCT NRTIPORELACIONA 
                FROM PARTICIPAVAL 
               WHERE NRPARCEXECAVAL = :P_NRPARCEXECAVAL
                 AND NRAVALIACAO IN (:P_NRAVALIACAO) 
                 AND NRTIPORELACIONA = 4";
        $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
        return $result;
    }

    public function retornaSeLider($params){
        $sql = "SELECT PARC.NMPRINCIPALPARC
                FROM PARTICIPAVAL P, EXECAVALIACAO E, TIPORELACIONA TR, PARCNEGOCIO PARC
                WHERE P.NRAVALIACAO    = E.NRAVALIACAO
                AND P.NRCOMBQUESTAVAL  = E.NRCOMBQUESTAVAL
                AND P.NRPARCAVALIADO   = E.NRPARCAVALIADO
                AND P.NRPARCEXECAVAL   = E.NRPARCEXECAVAL
                AND P.NRTIPORELACIONA  = TR.NRTIPORELACIONA
                AND P.NRPARCEXECAVAL   = PARC.NRPARCNEGOCIO
                AND P.IDSITUACAOAVAL   = 'CONCLUIDA'
                AND TR.NMTIPORELACIONA = 'LÃ­der'
                AND P.NRAVALIACAO      = :P_NRAVALIACAO
                AND P.NRCOMBQUESTAVAL  = :P_NRCOMBQUESTAVAL
                AND P.NRPARCEXECAVAL   = (SELECT NRPARCNEGOCIO FROM OPERADOR WHERE CDOPERADOR = :P_CDOPERADOR)
                AND P.VRRESULTAVALIA IS NOT NULL
                GROUP BY PARC.NMPRINCIPALPARC";
	try {
             $resultVerifLider = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
        return $resultVerifLider;
    }
    
    
    public function notificaPendentesAvaliacaoRepository($params){
        
        $sql = "SELECT PA.NRPARCEXECAVAL NRPARCEXECAVAL, EXEC.NMPRINCIPALPARC NMPRINCIPALPARC, OP.DSEMAILOPER
                FROM PARTICIPAVAL PA, PARCNEGOCIO AVAL, PARCNEGOCIO EXEC, COMBQUESTAVAL COMB,
                  TIPORELACIONA TR, OPERADOR OP, FUNCIONARIO FUN_AVAL, FUNCIONARIO FUN_EXEC
                WHERE PA.NRCOMBQUESTAVAL = COMB.NRCOMBQUESTAVAL
                AND PA.NRPARCAVALIADO = AVAL.NRPARCNEGOCIO
                AND PA.NRPARCEXECAVAL = EXEC.NRPARCNEGOCIO
                AND OP.NRPARCNEGOCIO = EXEC.NRPARCNEGOCIO
                AND AVAL.NRPARCNEGOCIO = FUN_AVAL.NRPARCNEGOCIO
                AND FUN_AVAL.DTDESLFUNC IS NULL
                AND EXEC.NRPARCNEGOCIO = FUN_EXEC.NRPARCNEGOCIO
                AND FUN_EXEC.DTDESLFUNC IS NULL
                AND PA.IDSITUACAOAVAL = 'CONCLUIDA'
                AND PA.NRTIPORELACIONA = TR.NRTIPORELACIONA
                AND TR.NMTIPORELACIONA = 'LÃ­der'
                AND PA.NRAVALIACAO = :P_NRAVALIACAO
                AND EXEC.NRPARCNEGOCIO||AVAL.NRPARCNEGOCIO NOT IN 
                  (
                    SELECT PLA.NRPARCEXECAVAL||PLA.NRPARCNEGOCIO 
                      FROM 
                        (
                          SELECT SUB.NRPARCEXECAVAL, SUB.NRPARCNEGOCIO, SUM(SUB.NRPRIORPLANACAO) TOTAL_PRIORIDADE
                          FROM PLANACAOAVL SUB
                          WHERE SUB.NRAVALIACAO = :P_NRAVALIACAO
                          GROUP BY SUB.NRPARCEXECAVAL, SUB.NRPARCNEGOCIO
                          HAVING SUM(SUB.NRPRIORPLANACAO) = 10
                        ) PLA
                  )
                AND OP.DSEMAILOPER IS NOT NULL
                GROUP BY PA.NRPARCEXECAVAL, EXEC.NMPRINCIPALPARC, OP.DSEMAILOPER
                ORDER BY EXEC.NMPRINCIPALPARC";
	try {
             $lideres = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
        
        return $lideres;
    }
    
    
    public function retornaAcoesPendentes($params){
        
        $sql = "SELECT AVAL.NMPRINCIPALPARC NMPRINCIPALPARC
                FROM PARTICIPAVAL PA, PARCNEGOCIO AVAL, PARCNEGOCIO EXEC, COMBQUESTAVAL COMB,
                  TIPORELACIONA TR
                WHERE PA.NRCOMBQUESTAVAL = COMB.NRCOMBQUESTAVAL
                AND PA.NRPARCAVALIADO = AVAL.NRPARCNEGOCIO
                AND PA.NRPARCEXECAVAL = EXEC.NRPARCNEGOCIO
                AND PA.IDSITUACAOAVAL = 'CONCLUIDA'
                AND PA.NRTIPORELACIONA = TR.NRTIPORELACIONA
                AND TR.NMTIPORELACIONA IN ('LÃ­der', 'AutoavaliaÃ§Ã£o')
                AND PA.NRAVALIACAO = :P_NRAVALIACAO
                AND PA.NRPARCEXECAVAL = :P_NRPARCEXECAVAL
                AND EXEC.NRPARCNEGOCIO||AVAL.NRPARCNEGOCIO NOT IN 
                  (
                    SELECT PLA.NRPARCEXECAVAL||PLA.NRPARCNEGOCIO 
                      FROM 
                        (
                          SELECT SUB.NRPARCEXECAVAL, SUB.NRPARCNEGOCIO, SUM(SUB.NRPRIORPLANACAO) TOTAL_PRIORIDADE
                          FROM PLANACAOAVL SUB
                          WHERE SUB.NRAVALIACAO = :P_NRAVALIACAO
                          AND SUB.NRPARCEXECAVAL = :P_NRPARCEXECAVAL
                          GROUP BY SUB.NRPARCEXECAVAL, SUB.NRPARCNEGOCIO
                          HAVING SUM(SUB.NRPRIORPLANACAO) = 10
                        ) PLA
                  )
                ORDER BY AVAL.NMPRINCIPALPARC";
	try {
             $lideres = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
        
        return $lideres;
    }
    
    
    public function notificaExpiradosAvaliacaoRepository($params){
        
        $sql = "SELECT PA.NRPARCEXECAVAL NREXEC, EXEC.NMPRINCIPALPARC NMEXEC, OP.DSEMAILOPER
                                    FROM PARTICIPAVAL PA, PARCNEGOCIO AVAL, PARCNEGOCIO EXEC, COMBQUESTAVAL COMB,
                                      TIPORELACIONA TR, OPERADOR OP
                                    WHERE PA.NRCOMBQUESTAVAL = COMB.NRCOMBQUESTAVAL
                                    AND PA.NRPARCAVALIADO = AVAL.NRPARCNEGOCIO
                                    AND PA.NRPARCEXECAVAL = EXEC.NRPARCNEGOCIO
                                    AND OP.NRPARCNEGOCIO = EXEC.NRPARCNEGOCIO
                                    AND PA.IDSITUACAOAVAL = 'CONCLUIDA'
                                    AND PA.NRTIPORELACIONA = TR.NRTIPORELACIONA
                                    AND TR.NMTIPORELACIONA = 'LÃ­der'
                                    AND PA.NRAVALIACAO = :P_NRAVALIACAO
                                    AND EXEC.NRPARCNEGOCIO||AVAL.NRPARCNEGOCIO IN
                                      (
                                        SELECT PLA.NRPARCEXECAVAL||PLA.NRPARCNEGOCIO
                                          FROM
                                            (
                                              SELECT SUB.NRPARCEXECAVAL, SUB.NRPARCNEGOCIO
                                              FROM PLANACAOAVL SUB
                                              WHERE SUB.NRAVALIACAO = :P_NRAVALIACAO
                              AND SUB.DTCONCLPLANACAO <= SYSDATE
                              AND SUB.DTTERMPLANACAO IS NULL

                                              ) PLA
                                      )
                                    GROUP BY PA.NRPARCEXECAVAL, EXEC.NMPRINCIPALPARC, OP.DSEMAILOPER
                                    ORDER BY EXEC.NMPRINCIPALPARC";
	try {
             $lideres = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
        
        return $lideres;
    }    
    
    
    
    public function retornaAcoesExpiradas($params){
        
        $sql = "SELECT AVAL.NMPRINCIPALPARC NMPRINCIPALPARC, aval.nrparcnegocio 
                FROM PARTICIPAVAL PA, PARCNEGOCIO AVAL, PARCNEGOCIO EXEC, COMBQUESTAVAL COMB,
                  TIPORELACIONA TR
                WHERE PA.NRCOMBQUESTAVAL = COMB.NRCOMBQUESTAVAL
                AND PA.NRPARCAVALIADO = AVAL.NRPARCNEGOCIO
                AND PA.NRPARCEXECAVAL = EXEC.NRPARCNEGOCIO
                AND PA.IDSITUACAOAVAL = 'CONCLUIDA'
                AND PA.NRTIPORELACIONA = TR.NRTIPORELACIONA
                AND TR.NMTIPORELACIONA = 'LÃ­der'
                AND PA.NRAVALIACAO = :P_NRAVALIACAO
                AND PA.NRPARCEXECAVAL = :P_NRPARCEXECAVAL
                AND EXEC.NRPARCNEGOCIO||AVAL.NRPARCNEGOCIO IN
                  (
                    SELECT PLA.NRPARCEXECAVAL||PLA.NRPARCNEGOCIO
                      FROM
                        (
                          SELECT SUB.NRPARCEXECAVAL, SUB.NRPARCNEGOCIO, SUB.DTCONCLPLANACAO ,SUB.DTTERMPLANACAO
                          FROM PLANACAOAVL SUB
                          WHERE SUB.NRAVALIACAO = :P_NRAVALIACAO
                          AND SUB.NRPARCEXECAVAL = :P_NRPARCEXECAVAL

                          AND SUB.DTCONCLPLANACAO <= SYSDATE
                AND SUB.DTTERMPLANACAO is NULL
                        ) PLA
                  )
                ORDER BY AVAL.NMPRINCIPALPARC";
	try {
             $lideres = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
        
        return $lideres;
    }
    
}