<?php

require_once 'base/FpaGrpitemEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 * 
 * @package Entity
 * 
 * @author  alessandrobartels
 */
class FpaGrpitemEntity extends FpaGrpitemEntityBase {


    private $_nrGrpIncidAnterior = -1;

    private function _inicializaLista($nrOrg, $nrOrgPadrao, $nrGrupoIncidencia) {

        $itensGrupo = FpaGrpitem::retornaItensGrupoPorGrupoIncidencia($nrOrg, $nrOrgPadrao, $nrGrupoIncidencia);

        foreach ($itensGrupo as $item) {
            $this->addItem($item, $item->getNritem());
        }
    }

    public function carregaItensGrupoPorGrupoIncidencia($nrOrg, $nrOrgPadrao, $nrGrupoIncidencia) {

        if ($this->_nrGrpIncidAnterior !== $nrGrupoIncidencia) {
            $this->resetItems();
            $this->_inicializaLista($nrOrg, $nrOrgPadrao, $nrGrupoIncidencia);
            $this->_nrGrpIncidAnterior = $nrGrupoIncidencia;
        } else {
//        $itens = $this->getItems();
//        if (count($itens) === 0) {
            if ($this->countItems() === 0) {
                $this->_inicializaLista($nrOrg, $nrOrgPadrao, $nrGrupoIncidencia);
            }
        }

    }

    /**
     * @param $valor
     * @return float
     * 20/07/2012
     */
    public function calculaValor($valor){
        $percentual = $this->getVrpercent();
        if ($percentual !== 100 && empty($percentual) === false) {
            $valor = ($valor * $percentual) / 100;
        }

        $multiplicador = $this->getVrmultiplic();
        if ($multiplicador !== 1 && empty($multiplicador) === false) {
            $valor = $valor * $multiplicador;
        }

        $divisor = $this->getVrdivide();
        if ($divisor !== 1 && empty($divisor) === false) {
            $valor = $valor / $divisor;
        }

        // alessandrobartels - 04/09/2012 - Implementacao de piso e teto
        $piso = $this->getVrpisoevento();
        if ($valor < $piso) {
            $valor = $piso;
        }

        $teto = $this->getVrtetoevento();
        if ($valor > $teto){
            $valor = $teto;
        }

        return (float)$valor;
    }


    /**
     * @param $valor
     * @return float
     * 20/07/2012
     */
    public function determinaReferencia(){
        switch($this->getIdrefgerar()){
        case FpaGrpitemEntity::IDREFGERAR_PERCENTUAL:
            $referencia = $this->getVrpercent();
            break;

        case FpaGrpitemEntity::IDREFGERAR_MULTIPLICADOR:
            $referencia = $this->getVrmultiplic();
            break;

        case FpaGrpitemEntity::IDREFGERAR_DIVISOR:
            $referencia = $this->getVrdivide();
            break;

        case FpaGrpitemEntity::IDREFGERAR_NENHUM:
            $referencia = $this->getVrreffixo();
            break;
        }

        return $referencia;
    }


    public function getTipoIncidencia($nrItem){
        $itemGrupo = $this->getItem($nrItem);
        if (is_object($itemGrupo) === true){
            $nrTipoIncidencia = $itemGrupo->getNrtipoincide();
            return $nrTipoIncidencia;
        } else {
            tk_warning('Tipo de incidencia nao parametrizado para o item '.$nrItem.'.');
            return null;
        }
    }


    public function calculaValorItemGrupoIncidencia($mesCompetencia, $itemCalculo, $evento, $nrItem){
        $valor = 0;
        $nrTipoIncidencia = $this->getTipoIncidencia($nrItem);
        if ($nrTipoIncidencia !== null){
            $valor = $itemCalculo->calculaIncidencias($nrTipoIncidencia, $mesCompetencia, $evento);
        }
        return $valor;
    }

    public function calculaReferenciaItemGrupoIncidencia($mesCompetencia, $itemCalculo, $evento, $nrItem){
        $referencia = 0;
        $nrTipoIncidencia = $this->getTipoIncidencia($nrItem);
        $referencia = $itemCalculo->calculaReferenciaIncidencias($nrTipoIncidencia, $mesCompetencia, $evento);
        return $referencia;
    }

    public function getListaIncidencias(){
        $listaTipoIncidencia = array();
        $itens = $this->getItems();
        foreach ($itens as $item){
            $nrItem = $item->getNritem();
            $listaTipoIncidencia[] = $this->getTipoIncidencia($nrItem);
        }

        return $listaTipoIncidencia;
    }

}

